package com.hammurapi.eventbus.tests.familyties.rules;

import java.io.ObjectInputStream;
import java.util.List;
import java.util.Map;

import com.hammurapi.extract.CompiledExtractorBase;
import com.hammurapi.extract.Extractor;
import com.hammurapi.extract.Predicate;

@SuppressWarnings("unchecked")
class Extractor12 extends CompiledExtractorBase<java.lang.Object, java.lang.Object, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>  {
	
	/**
	 * Class identity for comparison with other classes.
	 */
	private static final List<Object> IDENTITY;
	
	static {
		try {
			ObjectInputStream ois = new ObjectInputStream(Extractor12.class.getResourceAsStream("Extractor12.identity"));
			try {
				IDENTITY = (List<Object>) ois.readObject();
			} finally {
				ois.close();
			}
		} catch (Exception e) {
			throw new ExceptionInInitializerError(e);
		}
	}

	Extractor12(int[] map) {
		super(map, false, 1); 
	}

	@Override
	protected java.lang.Object extractInternal(com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules eCtx, Map<com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, Map<Extractor<java.lang.Object, ? super java.lang.Object, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>, ? super java.lang.Object>> cache, java.lang.Object... obj) {		
				
		com.hammurapi.eventbus.tests.familyties.model.Child anotherChild = (com.hammurapi.eventbus.tests.familyties.model.Child) obj[mapArg(1)];
				
		return anotherChild.getSubject();
	}

	@Override
	protected List<Object> getIdentity() {
		return IDENTITY;
	}

	@Override
	protected CompiledExtractorBase<java.lang.Object, java.lang.Object, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules> newInstance(int[] map) {
		return new Extractor12(map);
	}
	
	public String toString() {
		return getClass().getName()+" [Expression = anotherChild.getSubject(), Parameters = [Parameter[idx=0, type=class com.hammurapi.eventbus.tests.familyties.model.Child, name=anotherChild]], Parameter indices = "+parameterIndices()+"]";
	}
	
}
