package com.hammurapi.eventbus.tests.familyties.rules;

import java.util.HashSet;
import java.util.Set;

import com.hammurapi.eventbus.AbstractEventBus;
import com.hammurapi.eventbus.AbstractEventBus.Handle;
import com.hammurapi.eventbus.AbstractEventHandler;
import com.hammurapi.eventbus.EventDispatchContext;
import com.hammurapi.eventbus.EventHandler;
import com.hammurapi.eventbus.JavaBinder;
import com.hammurapi.extract.Predicate;

/**
 * Binds handler class com.hammurapi.eventbus.tests.familyties.rules.GrandRules to event bus com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus
 */
public class GrandRulesJavaBinder implements JavaBinder<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus, com.hammurapi.eventbus.tests.familyties.rules.GrandRules> {

	@Override
	public Set<java.lang.Long> bind(com.hammurapi.eventbus.tests.familyties.rules.GrandRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		Set<java.lang.Long> ret = new HashSet<java.lang.Long>();
		
				ret.add(infer(instance, bus));
				ret.add(infer0(instance, bus));
				ret.add(infer1(instance, bus));
				ret.add(infer2(instance, bus));
				
		return ret;
	}
	
		
	private java.lang.Long infer(final com.hammurapi.eventbus.tests.familyties.rules.GrandRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.And(0, null, new com.hammurapi.extract.CommutativeAnd(0, null, new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Son.class), new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(1), com.hammurapi.eventbus.tests.familyties.model.Parent.class)), new com.hammurapi.extract.Equal(0, null, new Extractor2(null), new Extractor3(null), false));
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(2, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.GrandSon toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Son) events[0],												
						(com.hammurapi.eventbus.tests.familyties.model.Parent) events[1]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.GrandSon com.hammurapi.eventbus.tests.familyties.rules.GrandRules.infer(com.hammurapi.eventbus.tests.familyties.model.Son,com.hammurapi.eventbus.tests.familyties.model.Parent), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long infer0(final com.hammurapi.eventbus.tests.familyties.rules.GrandRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.And(0, null, new com.hammurapi.extract.CommutativeAnd(0, null, new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(1), com.hammurapi.eventbus.tests.familyties.model.Parent.class), new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Daughter.class)), new com.hammurapi.extract.Equal(0, null, new Extractor4(null), new Extractor3(null), false));
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(2, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.GrandDaughter toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Daughter) events[0],												
						(com.hammurapi.eventbus.tests.familyties.model.Parent) events[1]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.GrandDaughter com.hammurapi.eventbus.tests.familyties.rules.GrandRules.infer(com.hammurapi.eventbus.tests.familyties.model.Daughter,com.hammurapi.eventbus.tests.familyties.model.Parent), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long infer1(final com.hammurapi.eventbus.tests.familyties.rules.GrandRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.And(0, null, new com.hammurapi.extract.CommutativeAnd(0, null, new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(1), com.hammurapi.eventbus.tests.familyties.model.Father.class), new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Child.class)), new com.hammurapi.extract.Equal(0, null, new Extractor5(null), new Extractor6(null), false));
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(2, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.GrandFather toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Child) events[0],												
						(com.hammurapi.eventbus.tests.familyties.model.Father) events[1]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.GrandFather com.hammurapi.eventbus.tests.familyties.rules.GrandRules.infer(com.hammurapi.eventbus.tests.familyties.model.Child,com.hammurapi.eventbus.tests.familyties.model.Father), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long infer2(final com.hammurapi.eventbus.tests.familyties.rules.GrandRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.And(0, null, new com.hammurapi.extract.CommutativeAnd(0, null, new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Child.class), new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(1), com.hammurapi.eventbus.tests.familyties.model.Mother.class)), new com.hammurapi.extract.Equal(0, null, new Extractor5(null), new Extractor7(null), false));
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(2, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.GrandMother toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Child) events[0],												
						(com.hammurapi.eventbus.tests.familyties.model.Mother) events[1]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.GrandMother com.hammurapi.eventbus.tests.familyties.rules.GrandRules.infer(com.hammurapi.eventbus.tests.familyties.model.Child,com.hammurapi.eventbus.tests.familyties.model.Mother), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
}
