package com.hammurapi.eventbus.tests.familyties.rules;

import java.util.HashSet;
import java.util.Set;

import com.hammurapi.eventbus.AbstractEventBus;
import com.hammurapi.eventbus.AbstractEventBus.Handle;
import com.hammurapi.eventbus.AbstractEventHandler;
import com.hammurapi.eventbus.EventDispatchContext;
import com.hammurapi.eventbus.EventHandler;
import com.hammurapi.eventbus.JavaBinder;
import com.hammurapi.extract.Predicate;

/**
 * Binds handler class com.hammurapi.eventbus.tests.familyties.rules.SiblingRules to event bus com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus
 */
public class SiblingRulesJavaBinder implements JavaBinder<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus, com.hammurapi.eventbus.tests.familyties.rules.SiblingRules> {

	@Override
	public Set<java.lang.Long> bind(com.hammurapi.eventbus.tests.familyties.rules.SiblingRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		Set<java.lang.Long> ret = new HashSet<java.lang.Long>();
		
				ret.add(infer(instance, bus));
				ret.add(infer0(instance, bus));
				
		return ret;
	}
	
		
	private java.lang.Long infer(final com.hammurapi.eventbus.tests.familyties.rules.SiblingRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Sibling.class);
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(1, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Sibling toPost  =  instance.infer(
																				
						wrap(context), 
																									
						(com.hammurapi.eventbus.tests.familyties.model.Sibling) events[0]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Sibling com.hammurapi.eventbus.tests.familyties.rules.SiblingRules.infer(com.hammurapi.eventbus.tests.familyties.FamilyTiesEventDispatchContext,com.hammurapi.eventbus.tests.familyties.model.Sibling), cardinality="+getCardinality();
			}
	
						
			private com.hammurapi.eventbus.tests.familyties.FamilyTiesEventDispatchContext wrap(final EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context) {
				return new com.hammurapi.eventbus.tests.familyties.FamilyTiesEventDispatchContext() {
		
					@Override
					public void post(com.hammurapi.eventbus.tests.familyties.model.Relative event, Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>... validators) {
						context.post(event, validators);
					}
		
					@Override
					public void consume(int index) {
						context.consume(index);
					}
		
					@Override
					public void consume(com.hammurapi.eventbus.tests.familyties.model.Relative event) {
						context.consume(event);
					}
		
					@Override
					public void update(com.hammurapi.eventbus.tests.familyties.model.Relative event) {
						context.update(event);
					}
		
					@Override
					public void removeHandler() {
						context.removeHandler();
					}
		
					@Override
					public com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore getEventStore() {
						return context.getEventStore();
					}
		
										
				};
			}
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long infer0(final com.hammurapi.eventbus.tests.familyties.rules.SiblingRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.And(0, null, new com.hammurapi.extract.CommutativeAnd(0, null, new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Child.class), new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(1), com.hammurapi.eventbus.tests.familyties.model.Child.class)), new com.hammurapi.extract.Not(new com.hammurapi.extract.Equal(0, null, new Extractor11(null), new Extractor12(null), false)), new com.hammurapi.extract.Equal(0, null, new Extractor5(null), new Extractor13(null), false));
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(2, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 instance.infer(
																				
						wrap(context), 
																									
						(com.hammurapi.eventbus.tests.familyties.model.Child) events[0],												
						(com.hammurapi.eventbus.tests.familyties.model.Child) events[1]												
				);
				
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public void com.hammurapi.eventbus.tests.familyties.rules.SiblingRules.infer(com.hammurapi.eventbus.tests.familyties.FamilyTiesEventDispatchContext,com.hammurapi.eventbus.tests.familyties.model.Child,com.hammurapi.eventbus.tests.familyties.model.Child), cardinality="+getCardinality();
			}
	
						
			private com.hammurapi.eventbus.tests.familyties.FamilyTiesEventDispatchContext wrap(final EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context) {
				return new com.hammurapi.eventbus.tests.familyties.FamilyTiesEventDispatchContext() {
		
					@Override
					public void post(com.hammurapi.eventbus.tests.familyties.model.Relative event, Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>... validators) {
						context.post(event, validators);
					}
		
					@Override
					public void consume(int index) {
						context.consume(index);
					}
		
					@Override
					public void consume(com.hammurapi.eventbus.tests.familyties.model.Relative event) {
						context.consume(event);
					}
		
					@Override
					public void update(com.hammurapi.eventbus.tests.familyties.model.Relative event) {
						context.update(event);
					}
		
					@Override
					public void removeHandler() {
						context.removeHandler();
					}
		
					@Override
					public com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore getEventStore() {
						return context.getEventStore();
					}
		
										
				};
			}
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
}
