package com.hammurapi.eventbus.tests.familyties.rules;

import java.util.HashSet;
import java.util.Set;

import com.hammurapi.eventbus.AbstractEventBus;
import com.hammurapi.eventbus.AbstractEventBus.Handle;
import com.hammurapi.eventbus.AbstractEventHandler;
import com.hammurapi.eventbus.EventDispatchContext;
import com.hammurapi.eventbus.EventHandler;
import com.hammurapi.eventbus.JavaBinder;
import com.hammurapi.extract.Predicate;

/**
 * Binds handler class com.hammurapi.eventbus.tests.familyties.rules.ParentChildRules to event bus com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus
 */
public class ParentChildRulesJavaBinder implements JavaBinder<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus, com.hammurapi.eventbus.tests.familyties.rules.ParentChildRules> {

	@Override
	public Set<java.lang.Long> bind(com.hammurapi.eventbus.tests.familyties.rules.ParentChildRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		Set<java.lang.Long> ret = new HashSet<java.lang.Long>();
		
				ret.add(infer(instance, bus));
				ret.add(infer0(instance, bus));
				
		return ret;
	}
	
		
	private java.lang.Long infer(final com.hammurapi.eventbus.tests.familyties.rules.ParentChildRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Parent.class);
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(1, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Child toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Parent) events[0]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Child com.hammurapi.eventbus.tests.familyties.rules.ParentChildRules.infer(com.hammurapi.eventbus.tests.familyties.model.Parent), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long infer0(final com.hammurapi.eventbus.tests.familyties.rules.ParentChildRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Child.class);
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(1, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Parent toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Child) events[0]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Parent com.hammurapi.eventbus.tests.familyties.rules.ParentChildRules.infer(com.hammurapi.eventbus.tests.familyties.model.Child), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
}
