package com.hammurapi.eventbus.tests.familyties.rules;

import java.util.HashSet;
import java.util.Set;

import com.hammurapi.eventbus.AbstractEventBus;
import com.hammurapi.eventbus.AbstractEventBus.Handle;
import com.hammurapi.eventbus.AbstractEventHandler;
import com.hammurapi.eventbus.EventDispatchContext;
import com.hammurapi.eventbus.EventHandler;
import com.hammurapi.eventbus.JavaBinder;
import com.hammurapi.extract.Predicate;

/**
 * Binds handler class com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules to event bus com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus
 */
public class SecondaryRulesJavaBinder implements JavaBinder<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus, com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules> {

	@Override
	public Set<java.lang.Long> bind(com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		Set<java.lang.Long> ret = new HashSet<java.lang.Long>();
		
				ret.add(infer(instance, bus));
				ret.add(infer0(instance, bus));
				ret.add(infer1(instance, bus));
				ret.add(infer2(instance, bus));
				ret.add(infer3(instance, bus));
				ret.add(infer4(instance, bus));
				ret.add(infer5(instance, bus));
				ret.add(infer6(instance, bus));
				ret.add(infer7(instance, bus));
				ret.add(infer8(instance, bus));
				
		return ret;
	}
	
		
	private java.lang.Long infer(final com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[2];
		
				
		predicates[0] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Sister.class);
				
		predicates[1] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(1), com.hammurapi.eventbus.tests.familyties.model.Parent.class);
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(2, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Aunt toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Sister) events[0],												
						(com.hammurapi.eventbus.tests.familyties.model.Parent) events[1]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Aunt com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules.infer(com.hammurapi.eventbus.tests.familyties.model.Sister,com.hammurapi.eventbus.tests.familyties.model.Parent), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long infer0(final com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[3];
		
				
		predicates[0] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Child.class);
				
		predicates[1] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(1), com.hammurapi.eventbus.tests.familyties.model.Child.class);
				
		predicates[2] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(2), com.hammurapi.eventbus.tests.familyties.model.Sibling.class);
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(3, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 instance.infer(
																				
						wrap(context), 
																									
						(com.hammurapi.eventbus.tests.familyties.model.Child) events[0],												
						(com.hammurapi.eventbus.tests.familyties.model.Child) events[1],												
						(com.hammurapi.eventbus.tests.familyties.model.Sibling) events[2]												
				);
				
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public void com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules.infer(com.hammurapi.eventbus.tests.familyties.FamilyTiesEventDispatchContext,com.hammurapi.eventbus.tests.familyties.model.Child,com.hammurapi.eventbus.tests.familyties.model.Child,com.hammurapi.eventbus.tests.familyties.model.Sibling), cardinality="+getCardinality();
			}
	
						
			private com.hammurapi.eventbus.tests.familyties.FamilyTiesEventDispatchContext wrap(final EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context) {
				return new com.hammurapi.eventbus.tests.familyties.FamilyTiesEventDispatchContext() {
		
					@Override
					public void post(com.hammurapi.eventbus.tests.familyties.model.Relative event, Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>... validators) {
						context.post(event, validators);
					}
		
					@Override
					public void consume(int index) {
						context.consume(index);
					}
		
					@Override
					public void consume(com.hammurapi.eventbus.tests.familyties.model.Relative event) {
						context.consume(event);
					}
		
					@Override
					public void update(com.hammurapi.eventbus.tests.familyties.model.Relative event) {
						context.update(event);
					}
		
					@Override
					public void removeHandler() {
						context.removeHandler();
					}
		
					@Override
					public com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore getEventStore() {
						return context.getEventStore();
					}
		
										
				};
			}
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long infer1(final com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Cousin.class);
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(1, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Cousin toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Cousin) events[0]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Cousin com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules.infer(com.hammurapi.eventbus.tests.familyties.model.Cousin), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long infer2(final com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.And(0, null, new com.hammurapi.extract.CommutativeAnd(0, null, new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Aunt.class), new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(1), com.hammurapi.eventbus.tests.familyties.model.Parent.class)), new com.hammurapi.extract.Equal(0, null, new Extractor8(null), new Extractor9(null), false));
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(2, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Cousin toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Aunt) events[0],												
						(com.hammurapi.eventbus.tests.familyties.model.Parent) events[1]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Cousin com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules.infer(com.hammurapi.eventbus.tests.familyties.model.Aunt,com.hammurapi.eventbus.tests.familyties.model.Parent), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long infer3(final com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[2];
		
				
		predicates[0] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Uncle.class);
				
		predicates[1] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(1), com.hammurapi.eventbus.tests.familyties.model.Parent.class);
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(2, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Cousin toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Uncle) events[0],												
						(com.hammurapi.eventbus.tests.familyties.model.Parent) events[1]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Cousin com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules.infer(com.hammurapi.eventbus.tests.familyties.model.Uncle,com.hammurapi.eventbus.tests.familyties.model.Parent), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long infer4(final com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.And(0, null, new com.hammurapi.extract.CommutativeAnd(0, null, new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Son.class), new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(1), com.hammurapi.eventbus.tests.familyties.model.Sibling.class)), new com.hammurapi.extract.Equal(0, null, new Extractor2(null), new Extractor10(null), false));
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(2, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Nephew toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Son) events[0],												
						(com.hammurapi.eventbus.tests.familyties.model.Sibling) events[1]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Nephew com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules.infer(com.hammurapi.eventbus.tests.familyties.model.Son,com.hammurapi.eventbus.tests.familyties.model.Sibling), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long infer5(final com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[2];
		
				
		predicates[0] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Wife.class);
				
		predicates[1] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(1), com.hammurapi.eventbus.tests.familyties.model.Uncle.class);
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(2, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Aunt toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Wife) events[0],												
						(com.hammurapi.eventbus.tests.familyties.model.Uncle) events[1]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Aunt com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules.infer(com.hammurapi.eventbus.tests.familyties.model.Wife,com.hammurapi.eventbus.tests.familyties.model.Uncle), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long infer6(final com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[2];
		
				
		predicates[0] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Brother.class);
				
		predicates[1] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(1), com.hammurapi.eventbus.tests.familyties.model.Parent.class);
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(2, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Uncle toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Brother) events[0],												
						(com.hammurapi.eventbus.tests.familyties.model.Parent) events[1]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Uncle com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules.infer(com.hammurapi.eventbus.tests.familyties.model.Brother,com.hammurapi.eventbus.tests.familyties.model.Parent), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long infer7(final com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[2];
		
				
		predicates[0] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Husband.class);
				
		predicates[1] = new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(1), com.hammurapi.eventbus.tests.familyties.model.Aunt.class);
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(2, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Uncle toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Husband) events[0],												
						(com.hammurapi.eventbus.tests.familyties.model.Aunt) events[1]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Uncle com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules.infer(com.hammurapi.eventbus.tests.familyties.model.Husband,com.hammurapi.eventbus.tests.familyties.model.Aunt), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
	private java.lang.Long infer8(final com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules instance, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventBus bus) {
		
		Predicate<com.hammurapi.eventbus.tests.familyties.model.Relative, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules>[] predicates = new Predicate[1];
		
				
		predicates[0] = new com.hammurapi.extract.And(0, null, new com.hammurapi.extract.CommutativeAnd(0, null, new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(1), com.hammurapi.eventbus.tests.familyties.model.Sibling.class), new com.hammurapi.extract.InstanceOfPredicate(new com.hammurapi.extract.IndexedExtractor(0), com.hammurapi.eventbus.tests.familyties.model.Daughter.class)), new com.hammurapi.extract.Equal(0, null, new Extractor4(null), new Extractor10(null), false));
				
		EventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> eventHandler = new AbstractEventHandler<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore>(2, 0, instance, true) {

			@Override
			public void post(EventDispatchContext<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, com.hammurapi.eventbus.AbstractEventBus.Handle<com.hammurapi.eventbus.tests.familyties.model.Relative, java.lang.Integer, com.hammurapi.eventbus.tests.familyties.rules.FamilyTiesRules, java.lang.Long>, com.hammurapi.eventbus.tests.familyties.FamilyTiesEventStore> context, com.hammurapi.eventbus.tests.familyties.model.Relative... events) {
				 com.hammurapi.eventbus.tests.familyties.model.Niece toPost  =  instance.infer(
																		
						(com.hammurapi.eventbus.tests.familyties.model.Daughter) events[0],												
						(com.hammurapi.eventbus.tests.familyties.model.Sibling) events[1]												
				);
				
				 
				
				if (com.hammurapi.eventbus.tests.familyties.model.Relative.class.isInstance(toPost)) {
					context.post(toPost);
				}
				 				
			}
			
			public String toString() {
				return "Compiled event handler for method public com.hammurapi.eventbus.tests.familyties.model.Niece com.hammurapi.eventbus.tests.familyties.rules.SecondaryRules.infer(com.hammurapi.eventbus.tests.familyties.model.Daughter,com.hammurapi.eventbus.tests.familyties.model.Sibling), cardinality="+getCardinality();
			}
	
				
		};
		
		return bus.addHandler(eventHandler, false, predicates);		
	}

		
}
